#include <windows.h>
#include "zlib.h"

HANDLE	hInstance;		// Global instance handle for  DLL
int   __export CALLBACK LibMain(HANDLE hInst, WORD wDataSeg, WORD cbHeapSize, LPSTR lpszCmdLine);
int   __export CALLBACK _WEP (int bSystemExit);

int __export CALLBACK LibMain(HANDLE hInst, WORD wDataSeg, WORD cbHeapSize, LPSTR lpszCmdLine)
{	hInstance = hInst;
	return(1);
}

#pragma alloc_text(FIXEDSEG, _WEP)
int __export CALLBACK _WEP (int bSystemExit)
{
    return(1);
}


#define BUF_IN	((uLong) 31000)
#define BUF_OUT ((uLong) 32000)

void hw_hmemcpy(unsigned char _huge * top, unsigned char _huge * fromp, unsigned int ui)
{ while (ui)
	{	*top++ = *fromp++;
		ui--;
	}
}

int hw_compress (unsigned char _huge * dest, uLongf *destLen, unsigned char _huge * source, uLong sourceLen)
{	z_stream stream;
	int err, segs, flush;
	uInt uiToDo, _huge * uiPtr = (uInt _huge *) dest;
	unsigned char _huge *dhp, _huge * shp = source;
	// char * chp = (char *) "1.0.4";
	Bytef * bip, * bop;
	uLong ulLeft = sourceLen / BUF_IN;
	GLOBALHANDLE in_gh, out_gh;
	segs = (int) ulLeft + 1;
	ulLeft *= BUF_IN;
	if (sourceLen > ulLeft)
		segs++;
	*destLen = sizeof(unsigned int) * segs;
	dhp = dest + *destLen;	
	*uiPtr = segs - 1;
	segs = 1;                       
	ulLeft = sourceLen;
	if (NULL == (in_gh = GlobalAlloc(GHND, (DWORD) BUF_IN))) // ALLOCATE MEMORY
		return Z_MEM_ERROR;
	if (NULL == (out_gh = GlobalAlloc(GHND, (DWORD) BUF_OUT))) // ALLOCATE MEMORY
	{ GlobalFree(in_gh);
		return Z_MEM_ERROR;
	}
	bip = (Bytef *) GlobalLock(in_gh);
	bop = (Bytef *) GlobalLock(out_gh);
	stream.next_in = (Bytef*) bip;
	stream.next_out = (Bytef*) bop;
	stream.avail_out = (uInt) BUF_OUT;;
	stream.zalloc = (alloc_func)0;
	stream.zfree = (free_func)0;
	stream.opaque = (voidpf)0;
	while (1)
	{	if (ulLeft > BUF_IN)
			uiToDo = (uInt) BUF_IN;
		else
			uiToDo = (uInt) ulLeft;
		hw_hmemcpy((unsigned char _huge *) bip, shp, uiToDo);
		shp += uiToDo;
		stream.next_in = (Bytef*) bip;
		stream.next_out = (Bytef*) bop;
		stream.avail_out = (uInt) BUF_OUT;;
		stream.zalloc = (alloc_func)0;
		stream.zfree = (free_func)0;
		stream.opaque = (voidpf)0;
		stream.avail_in = (uInt) uiToDo;
		err = deflateInit2_(&stream, Z_DEFAULT_COMPRESSION, Z_DEFLATED, 15, MAX_MEM_LEVEL, Z_FILTERED, ZLIB_VERSION, sizeof(z_stream));
		if (err != Z_OK) 
		{ GlobalUnlock(in_gh);
			GlobalFree(in_gh);
			GlobalUnlock(out_gh);
			GlobalFree(out_gh);
			return err;
		}
		// err = deflateInit(&stream, Z_DEFAULT_COMPRESSION);
// 		if (segs == 1)
//			deflateParams(&stream, Z_DEFAULT_COMPRESSION, Z_FILTERED);
		if (err != Z_OK) 
		{ GlobalUnlock(in_gh);
			GlobalFree(in_gh);
			GlobalUnlock(out_gh);
			GlobalFree(out_gh);
			return err;
		}
		// if (segs == (int) *uiPtr)
			flush = Z_FINISH;    // Z_NO_FLUSH
		// else
		// 	flush = Z_PARTIAL_FLUSH;
		err = deflate(&stream, flush);
		if (err != Z_STREAM_END)
		{	deflateEnd(&stream);
			GlobalUnlock(in_gh);
			GlobalFree(in_gh);
			GlobalUnlock(out_gh);
			GlobalFree(out_gh);
			return err == Z_OK ? Z_BUF_ERROR : err;
		}
		*destLen += (uLong) stream.total_out;
		*(uiPtr + segs) = (uInt) stream.total_out;
		hw_hmemcpy(dhp, (unsigned char _huge *) bop, (uInt) stream.total_out);		
		dhp += stream.total_out;
		err = deflateEnd(&stream);
		ulLeft -= (uLong) uiToDo;
		if (ulLeft == 0L)
		{	GlobalUnlock(in_gh);
			GlobalFree(in_gh);
			GlobalUnlock(out_gh);
			GlobalFree(out_gh);
			return err;
		}
		segs++;
	}
}

int hw_uncompress (unsigned char _huge *dest, unsigned char _huge *source)
{	z_stream stream;
	int err, segs, cntr;
	uInt uiLen;
	uLong ulOutOffset = 0L;
	Bytef * bip, * bop;
	GLOBALHANDLE in_gh, out_gh;
	unsigned char _huge * shp, _huge * dhp;
	uInt _huge * uiPtr = (uInt _huge *) source;
	segs = (uInt) *uiPtr;
	if (NULL == (in_gh = GlobalAlloc(GHND, (DWORD) BUF_OUT))) // ALLOCATE MEMORY
		return Z_MEM_ERROR;
	if (NULL == (out_gh = GlobalAlloc(GHND, (DWORD) BUF_IN))) // ALLOCATE MEMORY
	{ GlobalFree(in_gh);
		return Z_MEM_ERROR;
	}
	bip = (Bytef *) GlobalLock(in_gh);
	bop = (Bytef *) GlobalLock(out_gh);
	shp = source + ((segs + 1) * sizeof(uInt));
	dhp = dest;	
  stream.next_out = bop;
  stream.avail_out = (uInt) BUF_IN;
	stream.next_in = (Bytef*)bip;
  stream.zalloc = (alloc_func)0;
  stream.zfree = (free_func)0;
	for (cntr = 1; cntr <= segs; cntr++)
	{	if (cntr > 1)
			uiLen = *(uiPtr + cntr) - *(uiPtr + cntr - 1);
		else
			uiLen = *(uiPtr + cntr);
		hw_hmemcpy(bip, shp, uiLen);
		stream.avail_in = uiLen;
    err = inflateInit(&stream);
    if (err != Z_OK) 
    {	GlobalUnlock(in_gh);
			GlobalFree(in_gh);
			GlobalUnlock(out_gh);
			GlobalFree(out_gh);
    	return err;
    }
    err = inflate(&stream, Z_FINISH);
    if (err != Z_STREAM_END)
    {	inflateEnd(&stream);
    	GlobalUnlock(in_gh);
			GlobalFree(in_gh);
			GlobalUnlock(out_gh);
			GlobalFree(out_gh);
      return err;
    }
    hw_hmemcpy(dhp, (unsigned char _huge *) bop, (uInt) stream.total_out);
    dhp += stream.total_out;
    err = inflateEnd(&stream);
    if (err != Z_OK) 
    {	GlobalUnlock(in_gh);
			GlobalFree(in_gh);
			GlobalUnlock(out_gh);
			GlobalFree(out_gh);
    	return err;
    }
		shp	+= uiLen;
	}
	GlobalUnlock(in_gh);
	GlobalFree(in_gh);
	GlobalUnlock(out_gh);
	GlobalFree(out_gh);
	return err;
}


